/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_list_string_h_included
#define v3c_meta_treedb_list_string_h_included

#define COBJMACROS
#include <v3c/meta-treedb-list.h>

#ifdef __cplusplus
extern "C" {
#endif

extern treedb_list_backend_vtbl_t StringList_backend_vtbl;
extern void STDCALL StringList_Dump(treedb_list_ptr_t p);

#define StringList_PushBack(p, i) \
	treedb_list_t_PushBack(p, (HTREEDB_LISTDATA)(i))
#define StringList_PushFront(p, i) \
	treedb_list_t_PushFront(p, (HTREEDB_LISTDATA)(i))
#define StringList_PopBack(p) \
	treedb_list_t_PopBack(p)
#define StringList_PopFront(p) \
	treedb_list_t_PopFront(p)
#define StringList_Data(This, pv) \
	((const char *)pv + (This)->m_pImpl->m_pDescription->m_aligned_node_size)

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef v3c_meta_treedb_list_string_h_included */
