/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_string_tree_h_included
#define v3c_meta_treedb_string_tree_h_included

#define COBJMACROS
#include <v3c/meta-avl.h>

#ifdef __cplusplus
extern "C" {
#endif

extern treedb_tree_backend_vtbl_t StringTree_backend_vtbl;
extern void STDCALL StringTree_Dump(treedb_tree_ptr_t p);

#define StringTree_Insert(p, i) \
	treedb_tree_t_Insert(p, (HTREEDB_TREEKEY)(i), 0)
#define StringTree_Remove(p, i) \
	treedb_tree_t_Remove(p, (HTREEDB_TREEKEY)(i))
#define StringTree_Contains(p, i) \
	( treedb_tree_t_Search(p, (HTREEDB_TREEKEY)(i)) ? 1 : 0)
#define StringTree_Data(This, pv) \
	((const char *)pv + (This)->m_pImpl->m_pDescription->m_aligned_node_size)

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef v3c_meta_treedb_string_tree_h_included */
